package cn.ibizlab.core.uaa.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.Data;
import org.springframework.data.annotation.Transient;


import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.util.domain.EntityMP;

/**
 * 实体[统一资源]
 */
@Data
@TableName(value = "IBZPSSYSUNIRES",resultMap = "SYS_PSSYSUNIRESResultMap")
public class SYS_PSSYSUNIRES extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 实体2标识
     */
    @DEField(name = "sys_pssysuniresid" , isKeyField=true)
    @TableId(value= "sys_pssysuniresid",type=IdType.UUID)
    @JSONField(name = "sys_pssysuniresid")
    @JsonProperty("sys_pssysuniresid")
    private String sysPssysuniresid;
    /**
     * 实体2名称
     */
    @DEField(name = "sys_pssysuniresname")
    @TableField(value = "sys_pssysuniresname")
    @JSONField(name = "sys_pssysuniresname")
    @JsonProperty("sys_pssysuniresname")
    private String sysPssysuniresname;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 资源代码
     */
    @TableField(value = "unirescode")
    @JSONField(name = "unirescode")
    @JsonProperty("unirescode")
    private String unirescode;



    /**
     * 设置 [实体2名称]
     */
    public void setSysPssysuniresname(String sysPssysuniresname){
        this.sysPssysuniresname = sysPssysuniresname ;
        this.modify("sys_pssysuniresname",sysPssysuniresname);
    }
    /**
     * 设置 [资源代码]
     */
    public void setUnirescode(String unirescode){
        this.unirescode = unirescode ;
        this.modify("unirescode",unirescode);
    }
}






