package cn.ibizlab.core.uaa.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.uaa.domain.IBZPSSYSUNIRES;
import cn.ibizlab.core.uaa.filter.IBZPSSYSUNIRESSearchContext;
import cn.ibizlab.core.uaa.service.IIBZPSSYSUNIRESService;

import cn.ibizlab.util.helper.CachedBeanCopier;



import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.uaa.mapper.IBZPSSYSUNIRESMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[统一资源] 服务对象接口实现
 */
@Slf4j
@Service("IBZPSSYSUNIRESServiceImpl")
public class IBZPSSYSUNIRESServiceImpl extends ServiceImpl<IBZPSSYSUNIRESMapper, IBZPSSYSUNIRES> implements IIBZPSSYSUNIRESService {

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean save(IBZPSSYSUNIRES et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(IBZPSSYSUNIRES et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<IBZPSSYSUNIRES> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBZPSSYSUNIRES et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("ibzpssysuniresid",et.getIbzpssysuniresid())))
            return false;
        CachedBeanCopier.copy(get(et.getIbzpssysuniresid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<IBZPSSYSUNIRES> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    public boolean checkKey(IBZPSSYSUNIRES et) {
        return (!ObjectUtils.isEmpty(et.getIbzpssysuniresid()))&&(!Objects.isNull(this.getById(et.getIbzpssysuniresid())));
    }

    @Override
    @Transactional
    public IBZPSSYSUNIRES get(String key) {
        IBZPSSYSUNIRES et = getById(key);
        if(et==null){
            et=new IBZPSSYSUNIRES();
            et.setIbzpssysuniresid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean create(IBZPSSYSUNIRES et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getIbzpssysuniresid()),et);
        return true;
    }

    @Override
    public void createBatch(List<IBZPSSYSUNIRES> list) {
        saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        if(!removeById(key)) return false;
        return true ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    public IBZPSSYSUNIRES getDraft(IBZPSSYSUNIRES et) {
        return et;
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBZPSSYSUNIRES> searchDefault(IBZPSSYSUNIRESSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBZPSSYSUNIRES> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBZPSSYSUNIRES>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    @Override
    public List<JSONObject> select(String sql){
        return this.baseMapper.selectBySQL(sql);
    }

    @Override
    @Transactional
    public boolean execute(String sql){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


